load datosBenders;

f1=[c1; 1]; lb1=[zeros(n1,1); 0]'; lb2=zeros(n2,1);
Ap1=[A11 zeros(m1,1)]; Acut=[]; bcut=[];

Cotainf=[]; Cotasup=[]; min_Cotasup=inf;
tol=1e-2; erel=inf; MaxIter=20; iter=0;

while (iter<MaxIter) & (erel>tol),
  iter=iter+1;
  [x1,fval1]=linprog(f1,-Acut,-bcut,Ap1,b1,lb1);
  alpha=x1(end); x1=x1(1:end-1);
  Cotainf=[Cotainf; fval1];

  [x2,fval2,~,~,lambda]=linprog(c2,[],[],A22,b2-A21*x1,lb2);
  lam2=lambda.eqlin;
  Acut=[Acut; -lam2'*A21 1];
  bcut=[bcut; -b2'*lam2];

  Cotasup=[Cotasup; c1'*x1+fval2];
  if (min_Cotasup>Cotasup(end)),
    min_Cotasup=Cotasup(end);
    x=[x1; x2];
  end;
  erel=(min_Cotasup-Cotainf(length(Cotainf)))/min_Cotasup;
end;
